﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;

public class sounds : MonoBehaviour
{
    int objno = 0;
    rtcmixmain RTcmix;
    private bool did_start = false;

    float beeptime;


    private void Awake()
    {
        // find the RTcmixmain object with the RTcmix function definitions
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
    }


    // Use this for initialization
    void Start()
    {
        // initialize RTcmix
        RTcmix.initRTcmix(objno);

        RTcmix.SendScore("print_on()", objno);

        String score = "tty = \"" + Application.dataPath + "/sf/tty.wav\" " +
            "beep1 = \"" + Application.dataPath + "/sf/beep1.wav\" " +
            "beep2 = \"" + Application.dataPath + "/sf/beep2.wav\" " +
            "beep3 = \"" + Application.dataPath + "/sf/beep3.wav\" ";
        RTcmix.SendScore(score, objno);
        beeptime = Time.time + UnityEngine.Random.Range(1.0f, 5.0f);

        score = "rtinput(tty) " +
            "dur = 15 " +
            "amp = 1 " +
            "ampenv = maketable(\"line\", 1000, 0,0, 3,1, 12,1, 15,0) " +
            "MIX(0, 0, dur, amp*ampenv, 0, 1) " +
            "MAXBANG(10) " +
            "MAXMESSAGE(irand(1, 3), trand(1, 4)) ";
        RTcmix.SendScore(score, objno);

        did_start = true;
    }

    // Update is called once per frame
    void Update()
    {
    }

    void OnAudioFilterRead(float[] data, int channels)
    {
        if (!did_start) return;

        // compute sound samples
        RTcmix.runRTcmix(data, objno, 0);

        if (RTcmix.checkbangRTcmix(objno) == 1) {
            String score = "rtinput(tty) " + 
                "MIX(0, 0, dur, amp*ampenv, 0, 1) " +
                "MAXBANG(10) ";
            RTcmix.SendScore(score, objno);
        }

        // get the MAXMESSAGE to determine which 'beep' to trigger
        // this runs separately from the MAXBANG
        float [] vals;
        int nvals = RTcmix.checkvalsRTcmix(out vals, objno);
        if (nvals > 0) {
            String score;
            if (vals[0] == 1.0f) {
                score = "rtinput(beep1) " +
                    "MIX(0, 0, 0.2, 1, 0, 1) " +
                    "MAXMESSAGE(irand(1, 3), trand(1, 4)) ";
                RTcmix.SendScore(score, objno);
            }
            else if (vals[0] == 2.0f)
            {
                score = "rtinput(beep2) " +
                    "MIX(0, 0, 0.2, 1, 0, 1) " +
                    "MAXMESSAGE(irand(1, 3), trand(1, 4)) ";
                RTcmix.SendScore(score, objno);
            }
            else if (vals[0] == 3.0f)
            {
                score = "rtinput(beep3) " +
                    "MIX(0, 0, 0.2, 1, 0, 1) " +
                    "MAXMESSAGE(irand(1, 3), trand(1, 4)) ";
                RTcmix.SendScore(score, objno);
            }
        }

        RTcmix.printRTcmix(objno);
                     
    }


    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}
